
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Template_Classes &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Template_Classes</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">math</span>
<span class="kn">from</span> <span class="nn">Cleaning</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">os</span>

<div class="viewcode-block" id="Raw_Dataset"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Raw_Dataset">[docs]</a><span class="k">class</span> <span class="nc">Raw_Dataset</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for saving the dataset raw data as is.</span>

<span class="sd">    .. note::</span>
<span class="sd">        The following are required attributes.</span>

<span class="sd">    Required Attributes</span>
<span class="sd">    -------------------</span>
<span class="sd">    Name : str</span>
<span class="sd">        Battery name (&quot;B000X&quot;)</span>
<span class="sd">    cycle : list(Raw_Dataset.Raw_Cycle)</span>
<span class="sd">        List of the cycle objects</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">raw_file</span><span class="p">,</span> <span class="n">battery_number</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>

        <span class="c1"># Naming:</span>
        <span class="k">if</span> <span class="n">battery_number</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="c1"># If &#39;raw_file&#39; is already in the standard B0002 form</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">raw_file</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;.&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="c1"># You can number the battery yourself before calling the function</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span>


        <span class="c1"># Line for opening and exploring the raw_file</span>
        <span class="c1"># This will depend on the file type etc.</span>
        <span class="c1"># example for &#39;.mat&#39; files:</span>

        <span class="kn">import</span> <span class="nn">scipy.io</span>
        <span class="n">raw_data</span> <span class="o">=</span> <span class="n">scipy</span><span class="o">.</span><span class="n">io</span><span class="o">.</span><span class="n">loadmat</span><span class="p">(</span><span class="n">raw_file</span><span class="p">)</span>

        <span class="c1"># Then you&#39;ll have to work from there how to get the cycles etc.</span>
        <span class="c1"># Since this class is only for the raw data, you can customize</span>
        <span class="c1"># attributes etc. however you want. Only the Clean Battery has to follow</span>
        <span class="c1"># some rules to be compatible with other code.</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="c1"># This structure will depend on your file</span>
        <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">cycle</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">raw_data</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">Raw_Cycle</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">index</span><span class="p">))</span>
            <span class="c1"># Here, I&#39;m defining the cycle and data classes inside the class</span>
            <span class="c1"># This is better practice, I should have known better for the older</span>
            <span class="c1"># codes...</span>

        <span class="k">pass</span>

<div class="viewcode-block" id="Raw_Dataset.Raw_Cycle"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Raw_Dataset.Raw_Cycle">[docs]</a>    <span class="k">class</span> <span class="nc">Raw_Cycle</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;Class for storing Cycle data from raw battery data</span>

<span class="sd">        In some datasets, charge and discharge data come together in one file,</span>
<span class="sd">        there&#39;s no problem with that, you can save them as one single cycle</span>
<span class="sd">        here (not for the clean class).</span>
<span class="sd">        Check :py:mod:`MIT_Classes` to see how this is handled there.</span>

<span class="sd">        .. note::</span>
<span class="sd">            The following are required attributes.</span>

<span class="sd">        Required Attributes</span>
<span class="sd">        -------------------</span>
<span class="sd">        number : int</span>
<span class="sd">            The cycle number.</span>
<span class="sd">        type : {&#39;charge&#39;, &#39;discharge&#39;}</span>
<span class="sd">            The cycle type.</span>
<span class="sd">        amb_T : float</span>
<span class="sd">            The ambient temperature in which the battery was cycled [ºC]</span>
<span class="sd">        data : list(Raw_Dataset.Raw_Cycle.Raw_Data)</span>
<span class="sd">            List with the actual data objects</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">index</span><span class="p">):</span>

            <span class="c1"># From now on, I&#39;ll pretend cycle is like a dictionary</span>
            <span class="c1"># Of course, the rest of the code will depend on how this object is</span>
            <span class="c1"># structured</span>


            <span class="k">if</span> <span class="n">cycle</span><span class="p">[</span><span class="s1">&#39;number&#39;</span><span class="p">]</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                <span class="c1"># If the cycle contains its number:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">cycle</span><span class="p">[</span><span class="s1">&#39;number&#39;</span><span class="p">]</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># We&#39;ll give it an index.</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">index</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="n">cycle</span><span class="p">[</span><span class="s1">&#39;type&#39;</span><span class="p">]</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">cycle</span><span class="p">[</span><span class="s1">&#39;ambient_temperature&#39;</span><span class="p">])</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Raw_Data</span><span class="p">(</span><span class="n">cycle</span><span class="p">[</span><span class="s1">&#39;data&#39;</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">type</span><span class="p">)</span>

<div class="viewcode-block" id="Raw_Dataset.Raw_Cycle.Raw_Data"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Raw_Dataset.Raw_Cycle.Raw_Data">[docs]</a>        <span class="k">class</span> <span class="nc">Raw_Data</span><span class="p">:</span>
            <span class="sd">&quot;&quot;&quot;Class for storing the actual raw data.</span>

<span class="sd">            .. note::</span>
<span class="sd">                The following are required attributes.</span>

<span class="sd">            Required Attributes</span>
<span class="sd">            -------------------</span>
<span class="sd">            time : array like</span>
<span class="sd">                Time array [s]</span>
<span class="sd">            meas_i : array like</span>
<span class="sd">                Measured Current array [A]</span>
<span class="sd">            meas_v : array like</span>
<span class="sd">                Measured Voltage array [V]</span>
<span class="sd">            capacity : float</span>
<span class="sd">                Capacity value for the charge [A.h] (for discharge cycles).</span>

<span class="sd">            .. note::</span>
<span class="sd">                The following are recommended attributes for when the</span>
<span class="sd">                corresponding data is available.</span>

<span class="sd">            Recommended Attributes</span>
<span class="sd">            ----------------------</span>
<span class="sd">            meas_t : array like</span>
<span class="sd">                Measured temperature [ºC]</span>
<span class="sd">            meas_q : array like</span>
<span class="sd">                Measured capacity [A.h]</span>

<span class="sd">            &quot;&quot;&quot;</span>

            <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="s1">&#39;discharge&#39;</span><span class="p">):</span>

                <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;time&#39;</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;measured_current&#39;</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;measured_voltage&#39;</span><span class="p">]</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">meas_t</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;measured_temperature&#39;</span><span class="p">]</span>
                <span class="k">if</span> <span class="nb">type</span> <span class="o">==</span> <span class="s1">&#39;discharge&#39;</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">data</span><span class="p">[</span><span class="s1">&#39;capacity&#39;</span><span class="p">]</span></div></div></div>

<div class="viewcode-block" id="Clean_Dataset"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Clean_Dataset">[docs]</a><span class="k">class</span> <span class="nc">Clean_Dataset</span><span class="p">:</span>
    <span class="sd">&quot;&quot;&quot;Class for cleaning and storing clean data</span>

<span class="sd">    .. note::</span>
<span class="sd">        The following are required attributes.</span>

<span class="sd">    Required Attributes</span>
<span class="sd">    -------------------</span>
<span class="sd">    Name : str</span>
<span class="sd">        Battery name (&quot;B00XX&quot;).</span>
<span class="sd">    capacity_curve : array like</span>
<span class="sd">        A 2D array where the first column is the cycle number and the second is</span>
<span class="sd">        the capacity value [A.h] associated to it.</span>
<span class="sd">    cycle_couple : list(tuple(Clean_Dataset.Clean_Dataset_Cycle))</span>
<span class="sd">        A list with the cleaned charge and discharge cycles (respectively) that</span>
<span class="sd">        are associated one with the other (the charge cycle is always the one</span>
<span class="sd">        that comes immediately after the discharge cycle).</span>
<span class="sd">    C_rate : float</span>
<span class="sd">        The C rate associated to the battery for nondimensionning the</span>
<span class="sd">        current [A].</span>
<span class="sd">    Q_nominal : float</span>
<span class="sd">        The battery&#39;s nominal capacity (for nondimensionning the SOH) [A.h].</span>
<span class="sd">    V_nominal : float</span>
<span class="sd">        The battery&#39;s nominal voltage (for nondimensionning the voltage) [V].</span>


<span class="sd">    .. note::</span>
<span class="sd">        The following are recommended attributes.</span>

<span class="sd">        This has the purpose of simplifying things, but you&#39;ll still have to</span>
<span class="sd">        define them in the Dataset classes individually. That&#39;s why it&#39;s just</span>
<span class="sd">        recommended.</span>

<span class="sd">    Recommended Attributes</span>
<span class="sd">    ----------------------</span>
<span class="sd">    couples : list(tuple(int))</span>
<span class="sd">        When the charge and discharge data are in separate cycles, we need to</span>
<span class="sd">        first find the related couples. This will save their numbers so they can</span>
<span class="sd">        later be called.</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">Battery</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="o">=</span><span class="mf">2e-2</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">,</span>
                 <span class="n">z_lim</span><span class="o">=</span><span class="mi">3</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        Parameters</span>
<span class="sd">        ----------</span>
<span class="sd">        Battery : Raw_Dataset</span>
<span class="sd">            The Raw Battery we are going to clean and store here</span>
<span class="sd">        i_cutoff : float, default = 2e-2</span>
<span class="sd">            The current cut-off value to be used to determine the end of the</span>
<span class="sd">            charge cycles [A].</span>

<span class="sd">        min_len : int, default = 1</span>
<span class="sd">            The minimum amount of points a charge cycle must have to be</span>
<span class="sd">            considered as relevant. Equal to one by default. Something similar</span>
<span class="sd">            is done during the resampling stages in the dataset creation.</span>

<span class="sd">        threshold : float, default = 0.1</span>
<span class="sd">            the minimum capacity value to be considered as relevant [A.h].</span>
<span class="sd">        z_lim : float</span>
<span class="sd">            The maximum zscore allowed when searching for outliers.</span>
<span class="sd">        &quot;&quot;&quot;</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">Name</span> <span class="o">=</span> <span class="n">Battery</span><span class="o">.</span><span class="n">Name</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="p">[]</span>

        <span class="c1"># if the cycles are already separated in charge and discharge cycles:</span>
        <span class="c1"># self.couples = []</span>
        <span class="c1">#</span>
        <span class="c1"># Finding the couples:</span>
        <span class="c1">#</span>
        <span class="c1"># dis_nb = -1</span>
        <span class="c1"># for index, Cycle in enumerate(Battery.cycle):</span>
        <span class="c1">#     if Cycle.type == &#39;discharge&#39;:</span>
        <span class="c1">#             dis_nb = index</span>
        <span class="c1">#     elif Cycle.type == &#39;charge&#39;:</span>
        <span class="c1">#         if dis_nb != -1:</span>
        <span class="c1">#             chr_nb = index</span>
        <span class="c1">#             self.couples.append((chr_nb, dis_nb))</span>
        <span class="c1">#             dis_nb = -1</span>
        <span class="c1">#</span>
        <span class="c1"># for couple in self.couples:</span>
        <span class="c1">#   chr_cycle = Battery.cycle[couple[0]]</span>
        <span class="c1">#   dis_cycle = Battery.cycle[couple[1]]</span>
        <span class="c1">#   chr_cycle, dis_cycle = self.separate_and_clean(chr_cycle, dis_cycle)</span>
        <span class="c1">#   # continue from line 237 (&#39;if chr_cycle is None:&#39;...)</span>
        <span class="c1">#</span>

        <span class="c1"># if the charge and discharge cycles are stuck in one single cycle</span>
        <span class="c1"># entry:</span>

        <span class="k">for</span> <span class="n">cycle</span> <span class="ow">in</span> <span class="n">Battery</span><span class="o">.</span><span class="n">cycle</span><span class="p">:</span>
            <span class="n">chr_clean</span><span class="p">,</span> <span class="n">dis_clean</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">separate_and_clean</span><span class="p">(</span><span class="n">cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="p">,</span>
                                                           <span class="n">min_len</span><span class="p">,</span> <span class="n">threshold</span><span class="p">)</span>

            <span class="k">if</span> <span class="p">(</span><span class="n">chr_clean</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">dis_clean</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">):</span>
                <span class="k">continue</span>


            <span class="c1"># If cycles are in order discharge - charge:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_clean</span><span class="p">,</span> <span class="n">dis_clean</span><span class="p">))</span>
            <span class="c1"># else: #(we save this discharge cycle and wait for the next)</span>
            <span class="c1"># if len(self.cycle_couple) == 0:</span>
            <span class="c1">#     old_dis_clean = dis_clean</span>
            <span class="c1">#     self.cycle_couple.append(&#39;Wait&#39;) #</span>
            <span class="c1">#     continue</span>
            <span class="c1"># else:</span>
            <span class="c1">#     # Saving the cycle couple</span>
            <span class="c1">#     # print(chr_clean.number, old_dis_clean.number)</span>
            <span class="c1">#     self.cycle_couple.append((chr_clean, old_dis_clean))</span>
            <span class="c1">#     old_dis_clean = dis_clean</span>
            <span class="c1">#</span>
        <span class="c1"># self.cycle_couple.pop(0)  # Take out the &#39;Wait&#39; entry</span>

        <span class="c1"># Creating the cycle couple attribute:</span>
        <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">):</span>
            <span class="n">capacity_point</span> <span class="o">=</span> <span class="p">(</span><span class="n">index</span><span class="p">,</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">capacity</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">capacity_point</span><span class="p">)</span>

        <span class="c1"># Searching for outliers in the capacity data</span>
        <span class="n">cycle_couple</span><span class="p">,</span> <span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">Outliers</span><span class="p">(</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span><span class="p">,</span> <span class="n">z_lim</span><span class="o">=</span><span class="n">z_lim</span>
        <span class="p">)</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span> <span class="o">=</span> <span class="n">cycle_couple</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">capacity_curve</span> <span class="o">=</span> <span class="n">capacity_curve</span>

        <span class="bp">self</span><span class="o">.</span><span class="n">raw_couples</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">couples</span>     <span class="c1"># If it makes sense in this dataset</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">couples</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">cycle_couple</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">cycle_couple</span><span class="p">:</span>
            <span class="n">chr_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="n">dis_nb</span> <span class="o">=</span> <span class="n">cycle_couple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">number</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">couples</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">chr_nb</span><span class="p">,</span> <span class="n">dis_nb</span><span class="p">))</span>


<div class="viewcode-block" id="Clean_Dataset.separate_and_clean"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Clean_Dataset.separate_and_clean">[docs]</a>    <span class="k">def</span> <span class="nf">separate_and_clean</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="p">,</span> <span class="n">min_len</span><span class="p">,</span> <span class="n">threshold</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Separate cycles (if needed) and cleans them.</span>

<span class="sd">        I recommend looking at</span>
<span class="sd">        :func:`Coin_Classes.Clean_Cell.separate_coin_cycles` and</span>
<span class="sd">        :func:`Cleaning.Input_outliers_v3`.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1"># Do something that separates the cycles (if needed)</span>

        <span class="n">chr_cycle</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">dis_cycle</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">problem</span> <span class="o">=</span> <span class="kc">True</span>

        <span class="c1"># Then clean them (check other datasets for their cleaning methods).</span>
        
        <span class="c1"># Then call the clean cycle class</span>
        <span class="n">chr_clean</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Clean_Dataset_Cycle</span><span class="p">(</span><span class="n">chr_cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="p">,</span> <span class="n">min_len</span><span class="p">)</span>
        <span class="n">dis_clean</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Clean_Dataset_Cycle</span><span class="p">(</span><span class="n">dis_cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="p">,</span> <span class="n">min_len</span><span class="p">,</span>
                                             <span class="n">threshold</span><span class="p">)</span>
        <span class="c1"># If something goes wrong:</span>
        <span class="k">if</span> <span class="n">problem</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

        <span class="k">return</span> <span class="n">chr_clean</span><span class="p">,</span> <span class="n">dis_clean</span></div>


<div class="viewcode-block" id="Clean_Dataset.Clean_Dataset_Cycle"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Clean_Dataset.Clean_Dataset_Cycle">[docs]</a>    <span class="k">class</span> <span class="nc">Clean_Dataset_Cycle</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot;Creates a clean cycle class</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">cycle</span><span class="p">,</span> <span class="n">i_cutoff</span><span class="p">,</span> <span class="n">min_len</span><span class="p">,</span> <span class="n">threshold</span><span class="o">=</span><span class="mf">0.1</span><span class="p">):</span>

            <span class="bp">self</span><span class="o">.</span><span class="n">number</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">number</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">type</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">type</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">amb_T</span> <span class="o">=</span> <span class="n">cycle</span><span class="o">.</span><span class="n">amb_T</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">data</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">Clean_Data_Class</span><span class="p">(</span><span class="n">cycle</span><span class="o">.</span><span class="n">data</span><span class="p">)</span>
            <span class="k">pass</span>

        <span class="c1">#def clean_cycle(self):</span>
        <span class="c1">#    pass</span>

<div class="viewcode-block" id="Clean_Dataset.Clean_Dataset_Cycle.Clean_Data_Class"><a class="viewcode-back" href="../sphinx/Template%20Class.html#Template_Classes.Clean_Dataset.Clean_Dataset_Cycle.Clean_Data_Class">[docs]</a>        <span class="k">class</span> <span class="nc">Clean_Data_Class</span><span class="p">:</span>
            <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">data</span><span class="p">):</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">time</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">time</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">meas_i</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">meas_i</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">meas_v</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">meas_v</span>
                <span class="k">try</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">capacity</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">capacity</span>
                <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
                    <span class="k">pass</span></div></div></div>





</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>